/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>

 Description: 
 */

#ifndef PATTERN_INCLUDED
#define PATTERN_INCLUDED

#include "Parameters.h"

#include <string>
#include <map>
#include <vector>
#include <tr1/unordered_map>

using namespace std;
using namespace tr1;

typedef unordered_map <string, vector<unsigned>*> InvertedList;
//typedef vector<vector<unsigned>*> GramLists;


class Pattern
{
public:

	Pattern(string &_pattern);

	~Pattern();

	void CreateInvertedLists();

	vector<unsigned>* GetGramList(string gram);

	string GetNextGram();

	string GetGram(unsigned int startPos);

	bool IsCharExist(unsigned int mj);

	char GetChar(unsigned int mj);

	void SetPattern(string &_pattern);

	unsigned GetLength();


private:
	string pattern;
	vector<string> gramsInPattern;
	InvertedList invertedList;
};
#endif
